VERSION 5.00
Begin VB.Form frmOptions 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "General Settings"
   ClientHeight    =   3135
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4935
   Icon            =   "frmOptions.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3135
   ScaleWidth      =   4935
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkSound 
      Caption         =   "Enable &sound output"
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   540
      Width           =   2115
   End
   Begin VB.ComboBox cboModel 
      Height          =   315
      Left            =   1440
      Style           =   2  'Dropdown List
      TabIndex        =   8
      Top             =   120
      Width           =   3375
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2520
      TabIndex        =   5
      Top             =   2640
      Width           =   1095
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3720
      TabIndex        =   6
      Top             =   2640
      Width           =   1095
   End
   Begin VB.Frame fraStd 
      Caption         =   "&Emulation Speed"
      Height          =   1575
      Left            =   120
      TabIndex        =   0
      Top             =   900
      Width           =   4695
      Begin VB.OptionButton optSpeed200 
         Caption         =   "&Double - Limit emulation to 200% real Spectrum speed"
         Height          =   255
         Left            =   180
         TabIndex        =   3
         Top             =   900
         Width           =   4335
      End
      Begin VB.OptionButton optSpeed50 
         Caption         =   "&Slow - Limit emulation to 50% of real Spectrum speed"
         Height          =   255
         Left            =   180
         TabIndex        =   1
         Top             =   300
         Width           =   4395
      End
      Begin VB.OptionButton optSpeedFastest 
         Caption         =   "&Fastest - Do not limit emulation speed"
         Height          =   255
         Left            =   180
         TabIndex        =   4
         Top             =   1200
         Width           =   4275
      End
      Begin VB.OptionButton optSpeed100 
         Caption         =   "&Real - Limit emulation to 100% real Spectrum speed"
         Height          =   255
         Left            =   180
         TabIndex        =   2
         Top             =   600
         Width           =   4335
      End
   End
   Begin VB.Label lblStatic 
      Alignment       =   1  'Right Justify
      Caption         =   "Emulated &model:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   180
      Width           =   1275
   End
End
Attribute VB_Name = "frmOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' /*******************************************************************************
'   frmOptions.bas within vbSpec.vbp
'
'   Public variable declarations, startup and initialization code,
'   and routines for loading the ROM and snapshots
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)1999-2000 Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************/

Option Explicit

                                ' // Identifies the emulated model at the time
                                ' // the dialog is displayed. We need to reboot
Private lOriginalModel As Long  ' // the Spectrum if this changes.
                                
                                

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    If optSpeed50.Value Then
        glInterruptDelay = 40
    ElseIf optSpeed100.Value Then
        glInterruptDelay = 20
    ElseIf optSpeed200.Value Then
        glInterruptDelay = 10
    ElseIf optSpeedFastest.Value Then
        glInterruptDelay = 0
    End If
    SaveSetting "Grok", "vbSpec", "InterruptDelay", CStr(glInterruptDelay)
    
    glEmulatedModel = cboModel.ItemData(cboModel.ListIndex)
    If glEmulatedModel <> lOriginalModel Then
        ' // Modem has been changed - reboot the Spectrum
        SaveSetting "Grok", "vbSpec", "EmulatedModel", CStr(glEmulatedModel)
        Z80Reset
    End If
    
    
    SaveSetting "Grok", "vbSpec", "SoundEnabled", CStr(chkSound.Value)
    If gbSoundEnabled Then
        If chkSound.Value = 0 Then
            CloseWaveOut
        End If
    Else
        If chkSound.Value = 1 Then
            gbSoundEnabled = InitializeWaveOut
        End If
    End If

    Unload Me
End Sub

Private Sub Form_Load()
    Select Case glInterruptDelay
    Case 40
        ' // 40ms delay = 50% Spectrum speed
        optSpeed50.Value = True
    Case 20
        ' // 20ms delay = 100% Spectrum speed
        optSpeed100.Value = True
    Case 10
        ' // 10ms delay = 200% Spectrum speed
        optSpeed200.Value = True
    Case 0
        ' // 0 delay = run as fast as possible
        optSpeedFastest.Value = True
    End Select
    
    cboModel.AddItem "ZX Spectrum 48K"
    cboModel.ItemData(cboModel.NewIndex) = 0
    cboModel.AddItem "ZX Spectrum 128"
    cboModel.ItemData(cboModel.NewIndex) = 1
    cboModel.AddItem "ZX Spectrum +2"
    cboModel.ItemData(cboModel.NewIndex) = 2
    cboModel.AddItem "Timex TC2048"
    cboModel.ItemData(cboModel.NewIndex) = 5
    
    lOriginalModel = glEmulatedModel
    Select Case glEmulatedModel
    Case 0 ' // 48K
        cboModel.ListIndex = 0
    Case 1 ' // 128K
        cboModel.ListIndex = 1
    Case 2 ' // +2
        cboModel.ListIndex = 2
    Case 5 ' // TC2048
        cboModel.ListIndex = 3
    End Select
    
    chkSound.Enabled = True
    If gbSoundEnabled Then chkSound.Value = 1 Else chkSound.Value = 0
End Sub


